' ---------------------------------------------
' PIC16F877  LCD TIC8148
'    0  20  (PORTA.0)
'   0  10   (PORTA.1)
'   .. DIKLER -  05.04.2009
' dikler@mail.ru
'----------------------------------------------
CONFIG WDT_OFF , HS_OSC, PWRTE_OFF
'Set_Defaults PROTON_4
	Device 16F876
	DECLARE XTAL = 4

    DECLARE ADIN_RES 10 		' 10-bit result required 
	DECLARE ADIN_TAD FRC 		' RC OSC chosen 

    DECLARE ADIN_DELAY 50 		' Allow 50us sample time 

	TRISC = %11111111
	TRISB = %00011111
	TRISA = %00000011 			' Configure AN0 (PORTA.0) as an input 
	ADCON1 = %11000000	

	DIM VAR1 as WORD
	DIM VOLTS AS WORD
	DIM AMPER AS WORD
	DIM VOLTS1 AS FLOAT
	DIM AMPER1 AS FLOAT
	
	DIM U1 as WORD
	DIM A1 as WORD
	
	DIM tochka as bit
	
	'EDATA 915, 1024
	U1 = EREAD 0
	A1 = EREAD 2

'-----------------------
'---   ----
'-----------------------	
		'Dim BUF1 as Byte				'Working buffer 1 for button command
		'Dim BUF2 as Byte
		'Dim BUF3 as Byte
		'Dim BUF4 as Byte
		Symbol LOAD	= PORTB.7
		Symbol DIN	= PORTB.6
		Symbol DCLK	= PORTB.5
		
		Dim chas as byte
		Dim minut as byte
		Dim sek as byte
		
		Dim DXp as WORD '   
		Dim temp as BYTE
		Dim mask as BYTE
		Dim znak as BYTE
		Dim X as BYTE
		Dim digit as BYTE
		


		temp = 0
		mask = 0
		digit = 0
		X = 0
		
	 LOAD = 1
	 DIN = 1
	 DCLK = 1
	 sek = 0
	 minut = 9
	 chas = 20		
'===============================================================================
main:
	 call UAKUM
	 	 
	 AMPER1 = AMPER1 * 1.41
	 AMPER = AMPER1 * 10
	 	
	 temp = AMPER DIG 0
	 GOSUB getmask
	 digit = mask
	 tochka = 0
	 call digit_x
	 
	 temp = AMPER DIG 1
	 GOSUB getmask
	 digit = mask
	 tochka = 1
	 call digit_x 
	 
	 temp = AMPER DIG 2
	 GOSUB getmask
	 digit = mask
	 tochka = 0
	 call digit_x 

	 
	 temp = 10
	 GOSUB getmask
	 digit = mask
	 call digit_x	 
	 
	 VOLTS1 = VOLTS1 * 1.125
	 VOLTS = VOLTS1 * 100
	 
	 temp = VOLTS DIG 0
	 GOSUB getmask
	 digit = mask
	 tochka = 0
	 call digit_x
	 
	 temp = VOLTS DIG 1
	 GOSUB getmask
	 digit = mask
	 tochka = 0
	 call digit_x

	 temp = VOLTS DIG 2
	 GOSUB getmask
	 digit = mask
	 tochka = 1
	 call digit_x
	 
	 temp = VOLTS DIG 3
	 GOSUB getmask
	 digit = mask
	 tochka = 0
	 call digit_x
	
	 Toggle LOAD
	 nop
	 Toggle LOAD	
	
	
goto main	
'===============================================================================
digit_x:
	  'for znak = 0 to 7 step 1
	  
	  DIN = tochka
	  DCLK = 0
	  delayus 5
	  DCLK = 1
	  	  
	  DIN = 0
	  DCLK = 0
	  delayus 5
	  DCLK = 1	  
	  
	  DIN = digit.0
	  DCLK = 0
	  delayus 5
	  DCLK = 1
	  
	  DIN = digit.1
	  DCLK = 0
	  delayus 5
	  DCLK = 1
	  
	  DIN = digit.2
	  DCLK = 0
	  delayus 5
	  DCLK = 1
	  
	  DIN = digit.3
	  DCLK = 0
	  delayus 5
	  DCLK = 1
	  
	  DIN = digit.4
	  DCLK = 0
	  delayus 5
	  DCLK = 1
	  
	  DIN = digit.5
	  DCLK = 0
	  delayus 5
	  DCLK = 1
	  	  
	  DIN = digit.6
	  DCLK = 0
	  delayus 5
	  DCLK = 1
	    

	  
	  'next znak


return
'===============================================================================
getmask:	  				 '   7.    
	 mask = LookUp temp,[$6F, $03, $76, $57, $1B, $5D, $7D, $07, $7F, $5F, $10] 
	 Return

'===============================================================================
'----    ------
UAKUM:
	VAR1 = ADIN 0	' Place the conversion into variable VAR1 
	DELAYuS 1		' Wait for 1us 
	'PORTB = VAR1
	VOLTS1 = VAR1 * 50
	VOLTS1 = VOLTS1 / U1
'----    ------

	VAR1 = ADIN 1
	DELAYuS 1
	AMPER1 = 5 / A1
	AMPER1 = AMPER1 * VAR1
	AMPER1 = AMPER1 * 2

	RETURN
'------------------------------------
'===============================================================================




'===============================================================================
end
